******************************************************
*                 FORTH FOR K-OS ONE                 *
* COPYRIGHT 1987 JOSEPH BARTEL - ALL RIGHTS RESERVED *
******************************************************
* A7 - RETURN STACK
* A6 - PARAM STACK 
* A5 - BASE ADDRESS                          
* A4 - EXTENDED BASE ADDRESS -- 96 K+ 32K
* D7 - BYTE EXTENDER
* D6 - WORD EXTENDER
******************************************************
* * * * *  CHANGE 6-27-87 FOR 7 CHAR NAMES * * * * *
HEDSIZ	EQU	14		;14 BYTES FOR DICT HEAD
MACRO	EQU	$4000		;MARK WORD AS MACRO
IMMED	EQU	$2000		;MARK AS IMMEDIATE
	ORG	0
START	LEA	START-2(PC),A5	;SET BASE ADDRESS
	MOVEA.L	A5,A4		;SET EXTENDED BASE
	ADDA.L	#$10000,A4
	LEA	RTNSTK(A5),A7	;SET RETURN STACK
	LEA	PARSTK(A5),A6	;SET PARAMETER STACK  
	MOVEQ	#0,D6		;WORD EXTEND
	MOVEQ	#0,D7		;BYTE EXTEND
	MOVE.W	D7,LGGCNT(A5)	;CLEAR LOGIC COUNT
	MOVE.W	D7,LOPCNT(A5)	;CLEAR LOOP COUNT
*---- CLEAR ALL VARIABLES AND SET INITIAL VALUES
	LEA	VARS(A5),A0	;POINT TO FIRST VAR
	TST.L	(A0)		;CHECK OLD OR NEW
	BNE	STRT040
	MOVE.W	#DICTIN-VARS,D1	;COUNT TO CLEAR
	MOVEQ	#0,D0		;WITH 0
STRT020	MOVE.W	D0,(A0)+
	DBRA	D1,STRT020
	BSR	DECMAL		;SET BASE=10=DECIMAL
	MOVE.L	#FORTH,VOCAB(A5)
	MOVE.L	#FORTH,CONTEXT(A5)
	MOVE.L	CONTEXT(A5),CURRENT(A5)
	LEA	DICTIN(A5),A0	;FIRST USER LOC
	MOVE.L	A0,DICT(A5)
	MOVEQ	#-1,D0
	MOVE.L	D0,VARS(A5)	;MARK STARTED
	BRA	RESTART
;----------- OLD FILE LOADED
STRT040	MOVE.L	A5,D5
	ADD.L	D5,DICT(A5)	;UNREL IT
	ADD.L	D5,LAST(A5)	;UNREL IT
******************************************************
*              MAIN BODY OF KERNAL                   *
******************************************************
RESTART	BRA.S	RES040
	MOVE.L	RES010(A5),-(A6)	;PUSH ADRS
	JMP	EXECUTE(A5)
RES010	DC.L	0			;START ADRES
SIGN2	DC.B	'K-OS FORTH - READY',0
	EVEN
RES040	LEA	RTNSTK(A5),SP	;RESET RETURN STACK
	LEA	SIGN2(A5),A0
	MOVE.L	A0,-(A6)
	BSR	STRPRNT
	CLR.W	SRCFLG(A5)
	BSR	CR		;GET A LINE TO PROCESS
MAIN	MOVE.L	#32,-(A6)	;GET NEXT TOKEN
	JSR	WORD(A5)
	JSR	FIND(A5)	;LOOK FOR IT
	TST.L	(A6)+		;IF FOUND
	BEQ	TSTNUM
	TST.W	FIMMED(A5)	;IF IMMED FLAG OFF
	BNE	GODO
	TST.B	STATE(A5)	;IF IN COMPILE MODE
	BEQ.S	GODO
	JSR	COMPX(A5)	;COMPILE IT
	BRA	MAIN		;AND LOOP
GODO	BSR	EXECUTE		;ELSE EXECUTE WORD
	BSR	STKCHK		;AND CHECK STACK
	BRA	MAIN
TSTNUM	LEA	NBUF(A5),A0
	MOVE.L	A0,-(A6)	;PUSH TOKEN BUFFER ADRS
	JSR	NUMBER(A5)	;IS TOKEN NUMBER?
	TST.L	(A6)+		;IF NOT
	BNE	TSTCODE
	BSR	WHAZZAT		;REPLY "HUH?"
	BRA	MAIN
TSTCODE	TST.B	FCODE(A5)	;IF CODE ON
	BEQ	TSTLIT
	BSR	WCOMA
	BRA	MAIN
TSTLIT	TST.B	STATE(A5)	;IF IN COMPILE MODE
	BEQ	MAIN
	BSR	LITERAL
	BRA	MAIN
;---------------------------------------------------
STKCHK	LEA	PARSTK(A5),A0	;GET UNDERFLOW ADRS
	CMPA.L	A0,A6		;COMPARE TO STACK
	BLE	OKSTK		;GIVE "OK"
	BRA	STKU		;OR NASTYGRAM
OKSTK	RTS
	LEA	OKMS(A5),A0
	MOVEQ	#5,D0
	BRA	APR100
OKMS	DC.B	'  OK',13,10
;---------------------------------------------------
STKU	LEA	STK001(A5),A0
	MOVEQ	#17,D0
	BSR	APR100
	LEA	PARSTK(A5),A6	;RESET IT
	RTS		;================
STK001	DC.B	'STACK UNDERFLOW',10,13
	EVEN
;-------------------------------------------------
COLTST	TST.W	STATE(A5)
	BNE	COL900
	BSR	WHAZZAT
	BRA	RESTART
COL900	MOVEA.L	DICT(A5),A1
	RTS
;-------------------------------------------------
GETLINE	LEA	IBUF(A5),A0	;USE IBUF
	MOVE.L	A0,-(A6)
	MOVEQ	#80,D0
	MOVE.L	D0,-(A6)	;MAX 80 CHARS
	BSR	GETLIN
	LEA	IBUF(A5),A0	;SET SCAN POINTER
	MOVE.L	A0,SCPN(A5)
	ADDA.L	(A6)+,A0	;FIND END
	SUBQ.L	#1,A0
	LEA	GETL98(A5),A1	;END FIXUP
	MOVEQ	#GETL99-GETL98,D1
GETL100	MOVE.B	(A1)+,(A0)+
	DBRA	D1,GETL100
	RTS
GETL98	DC.B	' ',13,' ',0,'" ) ',13,' ',0
GETL99	DC.B	0
	EVEN
;---------------------------------
PROMPT	LEA	PRM001(A5),A0
	MOVEQ	#5,D0
	BRA	APR100
PRM001	DC.B	13,10,'OK '
	EVEN
*************** DICTIONARY WORDS ********************
*  DICTIONARY LINK IS RELATIVE                      *
*  DLXnnn  is word number                           *
*****************************************************
DLX001	DC.L	0		;END OF DICTIONARY
	DC.B	7,'EXECUTE'	;EXECUTE
	DC.W	0
EXECUTE	MOVE.L	(A6)+,D1
	JSR	0(A5,D1.L)
	RTS
;----------------------------------------
DLX002	DC.L	DLX001
	DC.B	1,'\',0,0,0,0,0,0
	DC.W	IMMED
SKIPN	BSR	GETCX		;GET A CHAR
	CMPI.B	#13,D0		;IF NOT CR
	BNE	SKIPN		;IGNORE IT
	BRA	CR		;EXIT VIA CR
;-------------------------------------------
DLX003	DC.L	DLX002
	DC.B	7,'WHAZZAT'		;WHAZZAT
	DC.W	0
WHAZZAT	LEA	WHA001(A5),A0
	MOVEQ	#6,D0
	BSR	APR100
	BSR	KEY		;====== DEBUG =====
	MOVE.L	(A6)+,D0	;==================
	CMPI.B	#3,D0		;====== CHECK ^C
	BEQ	SYSTEM		;====== BAIL OUT ===
	CMPI.B	#13,D0		;TRY CR
	BEQ	QUIT		;====== SIMPLE QUIT
	RTS
WHA001	DC.B	13,10,'????'    
;-------------------------------------
DLX004	DC.L	DLX003
	DC.B	4,'WORD',0,0,0	;WORD
	DC.W	0                     
WORD	LEA	NBUF(A5),A3	;POINT TO TOK BUF
	CLR.L	(A3)		;CLEAR TOKEN BUFFER
	CLR.L	4(A3)		;7 CHARS WORTH
	CLR.L	8(A3)		;====== 12
	CLR.L	12(A3)		;====== 16
	CLR.L	16(A3)		;====== 20
	CLR.L	D1		;CLEAR COUNT
WRD100	BSR	GETCX		;GET LINE OR DISK CHR
	CMP.B	3(A6),D0	;GET CHARS UNTIL DELIM
	BEQ	WRD999
	TST.W	SRCFLG(A5)
	BEQ	WRD200
      	CMPI.B	#13,D0		;DISK CR IS DELIM
	BEQ	WRD999		;DONT SAVE IT
WRD200	ANDI.W	#$7F,D0		;UPCASE
	CMPI.B	#'a',D0
	BLO.S	WRD300
	CMPI.B	#'z',D0
	BHI.S	WRD300
	SUB.W	#32,D0
WRD300	MOVE.B	D0,1(A3,D1)	;PUT IN TOKEN BUFFER
	ADDQ.B	#1,D1		;INC CHAR COUNT
	BRA	WRD100
WRD999	MOVE.B	D1,(A3)		;SAVE COUNT
	BEQ	WRD100		;IF COUNT=0, REPEAT
	MOVE.L	A3,(A6)		;RETURN ADRS
	RTS
;--------------------------------------
DLX005	DC.L	DLX004
	DC.B	1,13,0,0,0,0,0,0	;(CR)
	DC.W	IMMED
CR	TST.W	SRCFLG(A5)	;CHECK SOURCE FLAG
	BNE.S	CR020		;IGNORE IF DISK
	LEA	RTNSTK(A5),SP	;RESET SYSTEM STACK
	BSR	STKCHK
	BSR	PROMPT
	BSR	GETLINE		;GET A NEW LINE
	BRA	MAIN
CR020	RTS
;--------------------------------------
DLX006	DC.L	DLX005
	DC.B	4,'FIND',0,0,0	;FIND
	DC.W	0
FIND	MOVEA.L	(A6),A3		;SAVE TOKEN PNTR
	MOVE.L	CONTEXT(A5),-(A6)	;PUSH ADRS
	BSR.S	SEARCH
FXKIL	TST.L	(A6)		;CHECK FOUND
	BNE.S	FND300		;NZ IS FOUND
	MOVE.L	CONTEXT(A5),D0
	MOVE.L	#FORTH,D1
	CMP.L	D0,D1		;IF CONTEXT IF FORTH
	BEQ.S	FND300		;NO SEARCH
 	MOVE.L	A3,(A6)		;NEW TOKEN PNTR
	MOVE.L	D1,-(A6)	;TRY FORTH
	BRA.S	SEARCH
FND300	RTS
;--------------- USED BY FIND
SEARCH	MOVE.L	(A6)+,D3	;DICT TO SEARCH
	MOVEA.L	(A6)+,A1	;GET TOKEN PNTR
	MOVE.L	(A1)+,D1	;GET TOKEN "STEM"
	MOVE.L	(A1),D2		;NEXT 4 CHARS
	SF	FIMMED(A5)	;CLEAR IMMEDIATE FLAG
SRCH010	MOVE.L	0(A5,D3.L),D3	;GET LINK
	BEQ.S	SRCH020		;END IF Z
	LEA	0(A5,D3.L),A0	;MAKE ADRS
	CMP.L	4(A0),D1	;COMPARE
	BNE.S	SRCH010		;IF NOT SAME, TRY NEXT
	CMP.L	8(A0),D2	;LOW 4 BYTES
	BNE.S	SRCH010
	LEA	HEDSIZ(A0),A0	;GET CODE ADDRESS
	MOVE.W	-2(A0),D0	;GET TAG
	BTST	#13,D0		;CHECK IMM BIT
	SNE	FIMMED(A5)	;SET IMM FLAG
	SUBA.L	A5,A0		;MAKE REL
	MOVE.L	A0,-(A6)	;PUSH IT
	BRA	TRUE		;SET SUCCESS FLAG
SRCH020	CLR.L	-(A6)		;RETURN FAIL
	RTS
;--------------------------------------
DLX007	DC.L	DLX006
	DC.B	6,'NUMBER',0	;NUMBER
	DC.W	0
NUMBER	MOVEA.L	(A6)+,A0	;BUF POINTER
	MOVE.B	(A0)+,D1	;GET STRING SIZE
	MOVEQ	#0,D2		;START VALUE AT ZERO
	MOVEQ	#0,D4		;BEFORE DOT & +
	MOVEQ	#0,D6		;MARK PLUS
	MOVE.B	(A0),D7		;CHECK SIGN
	CMPI.B	#'-',D7		;ALLOW -
	BNE	NUM010
	MOVE.W	#-1,D6		;MARK NEGATIVE
	BRA	NUM015
NUM010	CMPI.B	#'+',D7		;ALLOW +
	BNE	NUM020
NUM015	ADDQ.L	#1,A0
	SUBQ.L	#1,D1
	BEQ	NUM900
NUM020	MOVE.B	(A0)+,D7	;GET CHAR IN BYTE REG
	SUBI.B	#48,D7		;REMOVE OFFSET
	BLT	NUM980		;IF LESS, FAIL
	CMPI.W	#10,D7		;IF >9
	BLT	NUM100
	SUBQ	#7,D7		;REMOVE ASCII OFFSET
      	CMPI.W	#10,D7
	BLT	NUM980		;IF <10, FAIL
NUM100	CMP.W	BASE+2(A5),D7	;COMPARE TO BASE
	BGE	NUM980		;IF >BASE, FAIL
 	MOVE.L	D2,D3		;COPY NUMBER
	SWAP	D3		;MOVE HIGH TO LOW
	MULU	BASE+2(A5),D3
	SWAP	D3		;MOVE LOW TO HIGH
	CLR.W	D3		;ZAP LOW PART
	MULU	BASE+2(A5),D2	;MULT LOW PART
	ADD.L	D3,D2		;ADD HIGH PART
      	ADD.L	D7,D2		;ADD NEW DIGIT
	SUBQ.B	#1,D1		;DEC DIGIT COUNTER
	BNE	NUM020  
NUM900	TST.W	D6		;CHECK SIGN
	BEQ	NUM950
	NEG.L	D2		;NEGATE IT
NUM950	MOVE.L	D2,-(A6)	;PUT ON STACK
	BRA	TRUE		;RETURN GOOD 
NUM980	BRA	FALSE		;NUMBER FAIL	
;--------------------------------------------------------------
DLX008	DC.L	DLX007
	DC.B	7,'CONVERT'	;CONVERT
	DC.W	0
CONVERT	MOVEA.L	(A6)+,A0	;BUF POINTER
	MOVE.B	(A0)+,D1	;GET STRING SIZE
	MOVE.L	(A6)+,D2	;GET SEED VALUE
CON020	MOVE.B	(A0)+,D7	;GET CHAR IN BYTE REG
	SUBI.B	#48,D7		;REMOVE OFFSET
	BLT.S	CON900		;IF LESS, FAIL
	CMPI.W	#10,D7		;IF >9
	BLT.S	CON100
	SUBQ	#7,D7		;REMOVE ASCII OFFSET
      	CMPI.W	#10,D7
	BLT.S	CON900		;IF <10, FAIL
CON100	CMP.W	BASE+2(A5),D7	;COMPARE TO BASE
	BGE.S	CON900		;IF >BASE, FAIL
 	MOVE.L	D2,D3		;COPY NUMBER
	SWAP	D3		;MOVE HIGH TO LOW
	MULU	BASE+2(A5),D3
	SWAP	D3		;MOVE LOW TO HIGH
	CLR.W	D3		;ZAP LOW PART
	MULU	BASE+2(A5),D2	;MULT LOW PART
	ADD.L	D3,D2		;ADD HIGH PART
      	ADD.L	D7,D2		;ADD NEW DIGIT
	SUBQ.B	#1,D1		;DEC DIGIT COUNTER
	BNE.S	CON020
CON900	MOVE.L	D2,-(A6)	;PUT ON STACK
	SUBQ.L	#1,A0		;BACK UP CHAR
	MOVE.L	A0,-(A6)
	RTS
;----------------------------------
DLX009	DC.L	DLX008
	DC.B	9,'[COMPIL'	;[COMPILE]
	DC.W	IMMED
	JSR	TIC(A5)		;GET NEXT WORD
COMPX	MOVEA.L	DICT(A5),A1	;GET POINTER
	MOVEA.L	(A6)+,A0	;GET REL CODE ADRES
	LEA	0(A0,A5.L),A2	;GET REAL ADRES
	MOVE.W	-2(A2),D0	;GET TAG
	BTST	#14,D0		;CHECK FOR MACO
	BEQ	COMP100		;IF Z, NOT MACRO
COMP040	MOVE.W	(A2)+,(A1)+	;COPY MACRO
	SUBQ.B	#1,D0
	BNE	COMP040
	BRA	COMP900
COMP100	MOVE.L	A0,D1		;COPY DEST ADRS
	CMP.W	#$7FFE,D1	;SEE IF IN RANGE
	BHS	COMP140
	MOVE.W	#$4EAD,(A1)+	;CODE JSR XX(A5)
	MOVE.W	D1,(A1)+	;OFFSET         
	BRA	COMP900
COMP140	MOVE.L	A0,D1		;TRY FOR BSR
	SUB.L	A1,D1		;FIGURE OFFSET
	SUBQ.L	#2,D1		;CORRECT FOR FIRST WORD
	SWAP	D1
	CMPI.W	#$FFFF,D1
	BEQ	COMP160
	TST.W	D1
	BNE	COMP200
COMP160	MOVE.W	#$6100,(A1)+	;CODE BSR
	MOVE.W	D1,(A1)+	;CODE OFFSET
	BRA	COMP900
COMP200	MOVE.W	#$203C,(A1)+	;MOVE #99,D0
	SUBA.L	A5,A0		;REMOVE BASE
	MOVE.L	A0,(A1)+	;CODE REL ADRES
	DC.W	$22FC		;CODE 4
	JSR	0(A5,D0.L)	;CODE
COMP900	MOVE.L	A1,DICT(A5)	;SAVE DICTIONARY
	RTS
;--------------------------------------
DLX010	DC.L	DLX009
	DC.B	6,'HEADER',0	;HEADER
	DC.W	0
HEADER	MOVEA.L	DICT(A5),A0	;LINK HEADER TO DICTIONARY
	MOVEA.L	CURRENT(A5),A1	;PNT TO ADRS
	SUBA.L	A5,A0		;MAKE BASED
	MOVEA.L	0(A5,A1.L),A2	;SET OLD LINK
	MOVE.L	A0,0(A5,A1.L)	;SET END OF VOC
	ADDA.L	A5,A0		;RESTORE BASE
	MOVE.L	A0,LAST(A5)	;SET LAST
	MOVE.L	NBUF(A5),4(A0)	;7 CHARS + COUNT
	MOVE.L	NBUF+4(A5),8(A0)	
	CLR.W	12(A0)
	MOVE.L	A2,(A0)		;PUT IN TABLE
	ADDA.L	#HEDSIZ,A0	;SPACE FOR HEADER
	MOVE.L	A0,DICT(A5)	;UPDATE DICT
	RTS                     
UNHEAD	MOVEA.L	LAST(A5),A0	;CURRENT
	MOVE.L	A0,DICT(A5)	;FIX DICT
	MOVE.L	(A0),D0                           
	MOVEA.L	CURRENT(A5),A0	;POINT TO ADRS
	MOVE.L	D0,0(A5,A0.L)	;UNLINK IT
	CLR.L	STATE(A5)	;EXIT COMPILE MODE
	RTS
;-----------------------------------------------------
DLX011	DC.L	DLX010
	DC.B	9,'IMMEDIA'	;IMMEDIATE
	DC.W	0       
	MOVEA.L	LAST(A5),A0	;ADDRESS OF LAST DEF
	ORI.W	#IMMED,-2(A0)	;SET IMMED BIT
	RTS
;-----------------------------------
DLX012	DC.L	DLX011
	DC.B	1,':',0,0,0,0,0,0	;COLON ':'
	DC.W	IMMED
COLON	TST.W	LOPCNT(A5)	;ZERO IF NOT IN COLON
	BNE	BADDY
	MOVEQ	#32,D0		;SPACE IS DELIM
	MOVE.L	D0,-(A6)
	BSR	WORD		;GET TOKEN
	ADDQ.L	#4,A6		;DROP ADRS
	BSR	HEADER		;MAKE HEADER
	MOVEQ	#1,D6
	MOVE.W	D6,LGGCNT(A5)	;SET LOGIC COUNT
	LEA	LGGPNT(A5),A1	;SET STK PNT
	MOVE.W	D6,-(A1)
	MOVE.L	A1,LGGPNT(A5)
	MOVE.W	D6,LOPCNT(A5)	;SET LOOP COUNT
	LEA	LOPSTK(A5),A1	;SET LOOP POINTER
	MOVE.W	D6,-(A1)	;FLAG LOOP :
	MOVE.L	A1,LOPSTK(A5)	;SAVE AS POINTER
	ST	STATE(A5)	;SET COLON FLAG
	RTS
;-----------------------------------
DLX013	DC.L	DLX012
	DC.B	7,'COMPILE'	;COMPILE
	DC.W	IMMED
	JSR	TIC(A5)		;GET ADRESS
	BSR	COLTST		;COLON AND DICT
	DC.W	$22FC
	JSR	CMPX(A5)	;RUN TIME
	MOVE.L	(A6)+,(A1)+	;RELATIVE ADRS
	MOVE.L	A1,DICT(A5)
	RTS
;----- RUN TIME FOR COMPILE
CMPX	MOVE.L	(SP)+,-(A6)	;GET ADRS
	JMP	COMPX(A5)	;COMPILE IT
;--------------------------------------
DLX014	DC.L	DLX013
	DC.B	1,';',0,0,0,0,0,0	;SEMI ';'
	DC.W	IMMED
SEMI	CLR.L	STATE(A5)	;CLEAR COLON FLAG
	CLR.B	FCODE(A5)	;ALSO CODE FLAG
	MOVEA.L	DICT(A5),A1	;GET DICT POINTER
	MOVE.W	#$4E75,(A1)+	;COMPILE RTS
	MOVE.L	A1,DICT(A5)	;SAVE POINTER
	SUBQ.W	#1,LGGCNT(A5)	;CHECK LOGIC STACK
	BNE	BADDY
	SUBQ.W	#1,LOPCNT(A5)	;CHECK LOOP STACK
	BNE	BADDY
	RTS        
BADDY	CLR.W	LGGCNT(A5)	;CLEAR ERROR
	CLR.W	LOPCNT(A5)	;CLEAR ERROR
	LEA	BADMES(A5),A0
	MOVE.L	A0,-(A6)
	JSR	STRPRNT(A5)
	BSR	UNHEAD		;UNDO HEADER
	BRA	WHAZZAT
BADMES	DC.B	'- UNBALANCED CONSTRUCT FOUND -',0
	EVEN
;--------------------------------------
DLX015	DC.L	DLX014
	DC.B	1,',',0,0,0,0,0,0	;COMMA ','
	DC.W	0
COMMA	MOVEA.L	DICT(A5),A1	;GET DICT POINTER
	MOVE.L	(A6)+,(A1)+	;POP WORD TO DICTIONARY
	MOVE.L	A1,DICT(A5)	;SAVE POINTER
	RTS
;---------------------------------
DLX016	DC.L	DLX015
	DC.B	7,'LITERAL'	;LITERAL
	DC.W	0
LITERAL	MOVEA.L	DICT(A5),A1
	MOVE.W	#$2D3C,(A1)+	;COMPILE MOVE.L #XX,-(A6)
	MOVE.L	(A6)+,(A1)+	;COMPILE CONSTANT
	MOVE.L	A1,DICT(A5)
	RTS
;----------------------------------------
DLX017	DC.L	DLX016
	DC.B	1,"'",0,0,0,0,0,0	;TIC '
	DC.W	0                             
TIC	MOVEQ	#32,D0		;FIND WORD
	MOVE.L	D0,-(A6)
	JSR	WORD(A5)
	JSR	FIND(A5)	;FIND WORD
	TST.L	(A6)+
	BEQ	WHAZZAT
	RTS
;----------------------------------------
DLX018	DC.L	DLX017
	DC.B	3,"[']",0,0,0,0	;[']
	DC.W	IMMED
	JSR	TIC(A5)  	;GET RELATIVE ADRS
	JMP	COMMA(A5)	;COMPILE IT
;----------------------------------------
DLX019	DC.L	DLX018
	DC.B	5,'GETCX',0,0	;GETCX
	DC.W	0
GETCX	TST.W	SRCFLG(A5)	;CHECK SOURCE FLAG
	BNE	GTX100		;NZ = DISK
	MOVEA.L	SCPN(A5),A0	;Z= TERMINAL
	MOVE.B	(A0)+,D0
	MOVE.L	A0,SCPN(A5)
	RTS                               
GTX100	TST.W	DSKCNT(A5)	;CHECK BYTE COUNT
	BNE	GTX200
	MOVEQ	#0,D0
	MOVE.W	DSKCHAN(A5),D0	;INPUT CHAN
	MOVE.L	D0,-(A6)
	LEA	DSKBUF(A5),A0	;BUFFER
	MOVE.L	A0,DSKBFPN(A5)	;SAVE POINTER
	MOVE.L	A0,-(A6)
	MOVE.L	#512,-(A6)	;512 BYTES EACH READ
	BSR	READFIL
	MOVE.L	(A6)+,D0	;GET COUNT
	BNE	GTX180
      	LEA	GTX170(A5),A0
	MOVE.L	A0,-(A6)
	BSR	STRPRNT
	BRA	RESTART
GTX170	DC.B	13,10,'+++ EOF DETECTED, LOAD ENDED +++',0
	EVEN
GTX180	MOVE.W	D0,DSKCNT(A5)
GTX200	MOVEQ	#0,D0		;PRPARE FOR BYTES
	MOVEA.L	DSKBFPN(A5),A0	;GET POINTER
	MOVE.B	(A0)+,D0
	MOVE.L	A0,DSKBFPN(A5)
	SUBQ.W	#1,DSKCNT(A5)	;DEC BYTE COUNT
	MOVE.W	D0,-(SP)	;====== DEBUG ECHO
	BSR	PUTD0		;====== DEBUG ECHO
	MOVE.W	(SP)+,D0	;====== DEBUG ECHO
;=====	CMPI.B	#13,D0		;CONVERT DISK CR
;=====	BEQ	GTX900		;TO SPACE
	CMPI.B	#10,D0		;LF
	BEQ	GTX900
	CMPI.B	#9,D0		;TAB
	BEQ	GTX900                
	RTS
GTX900	MOVEQ	#32,D0		;RETURN A SPACE
	RTS
;----------------------------------------
DLX020	DC.L	DLX019
	DC.B	4,'TRAP',0,0,0	;TRAP TO OS
	DC.W	0
;--- TRAP AND WAIT FOR RESULT
TRAP	MOVEA.L	(A6)+,A0	;POINT TO PARAMS
TRAP2	TRAP	#1		;SENT TO OS
TRP001	TST	2(A0)		;CHECK FOR DONE
	BPL	TRP001		;LOOP UNTIL MINUS
	RTS			;GO BACK
;----------------------------------------
DLX021	DC.L	DLX020
	DC.B	2,'DP',0,0,0,0,0	;DP
	DC.W	0
DICTCOD	LEA	DICT(A5),A0	;PUSH ADRES
	MOVE.L	A0,-(A6)
	RTS
;------------------------------------LOAD A KOS FILE
DLX022	DC.L	DLX021
	DC.B	4,'LOAD',0,0,0	;LOAD	
	DC.W	0
LOAD	MOVE.L	#32,-(A6)
	BSR	WORD		;GET PATH NAME
	BSR	OPENFIL		;TRY TO OPEN IT
	MOVE.L	(A6)+,D0	;GET RESULT
	BNE	LOD100
	BSR	WHAZZAT		;GIVE ???
	BSR	RESTART
LOD100	MOVE.W	D0,DSKCHAN(A5)	;SAVE CHANNEL NUMBER
	CLR.W	DSKCNT(A5)	;FORCE A READ IF CALLED
	ST	SRCFLG(A5)	;SET SOURCE=DISK
	LEA	LOD200(A5),A0	;====== DEBUG HELLO
	MOVE.L	A0,-(A6)	;======
	BSR	STRPRNT		;======
	RTS                            
LOD200	DC.B	'++ LOAD STARTED ++',13,10,0
	EVEN
;----------------------------------------
DLX023	DC.L	DLX022
	DC.B	5,'ABORT',0,0	;ABORT
	DC.W	0                     
ABORT	LEA	RTNSTK(A5),SP	;CLEAR RETURN
	LEA	PARSTK(A5),A6	;CLEAR PARAM
	BRA	QUIT		;THEN QUIT
;----------------------------------------
DLX024	DC.L	DLX023
	DC.B	4,'SAVE',0,0,0	;SAVE
	DC.W	0
SAVE	MOVE.L	#32,-(A6)
	BSR	WORD  
	BSR	MAKFIL		;CREATE A FILE
	MOVE.L	(A6)+,D0
	LEA	NBUF(A5),A0
	MOVE.L	A0,-(A6)
	BSR	OPENFIL
	MOVE.L	(A6)+,D0
	BNE	SAV100
	BSR	WHAZZAT		;NO GOOD, ABORT
	BRA	RESTART
SAV100	MOVE.L	A5,D5
	SUB.L	D5,DICT(A5)	;REMOVE BASE
	SUB.L	D5,LAST(A5)
	ST	VARS(A5)	;MARK AS OLD
	MOVE.W	D0,DSKCHAN(A5)  
	MOVE.L	D0,-(A6)	;CHAN
	MOVE.L	A5,-(A6)	;BUF ADRS
	MOVE.L	DICT(A5),-(A6)	;SIZE
	BSR	WRITFIL
	MOVE.L	(A6)+,D0
	MOVE.W	DSKCHAN(A5),D0
	MOVE.L	D0,-(A6)
	BSR	CLOSFIL
        ADDQ.L	#4,A6		;DROP
	MOVE.L	A5,D5
	ADD.L	D5,DICT(A5)	;FIX BASE
	ADD.L	D5,LAST(A5)
	LEA	SAV200(A5),A0	;==== DEBUG MESSAGE
	MOVE.L	A0,-(A6)	;====
	BSR	STRPRNT		;====
	RTS                          
SAV200	DC.B	'++ FORTH SAVED ++',13,10,0
	EVEN
;----------------------------------------
DLX025	DC.L	DLX024
	DC.B	4,'TYPE',0,0,0	;TYPE
	DC.W	0
;--- PRINT AN ARRAY OF BYTES ( adr count -- )
TYPE	MOVE.L	(A6)+,D0	;GET COUNT
	MOVEA.L	(A6)+,A0	;GET START ADRS
APR100	MOVE.W	#3,PBLK1(A5)	;SET WRITE
	CLR.L	PBLK1+2(A5)	;CLEAR STATUS FOR DEBUG
	MOVE.W	#1,PBLK1+4(A5)	;SEND TO CONSOLE
	MOVE.W	D0,PBLK1+6(A5)	;BYTE COUNT
	MOVE.L	A0,PBLK1+10(A5)	;BUFFER ADDRESS
	LEA	PBLK1(A5),A0
	BSR	TRAP2		;SEND IT
	RTS
;----------------------------------------
DLX026	DC.L	DLX025
	DC.B	1,'.',0,0,0,0,0,0	;PRINT '.'
	DC.W	0
PRINT	JSR	LSSARP(A5)		;<S#
	JSR	SHRPS(A5)		;#S
	JSR	SSIGN(A5)		;SSIGN
	JSR	GRTSRP(A5)		;#>
	JSR	TYPE(A5)		;TYPE
	JMP	SPACE(A5)		;SPACE ;
;----------------------------------------
DLX027	DC.L	DLX026
	DC.B	2,'.S',0,0,0,0,0	;  .S
	DC.W	0
SPRINT	LEA	PARSTK(A5),A1	;GET ADRES OF STK BTM
	MOVEA.L	A6,A2
BOTTOM	CMPA.L	A1,A2		;WHILE ABOVE BOTTOM
	BGE	DONE
	MOVE.L	-(A1),-(A6)	;PUSH NEXT NUMBER
	MOVE.L	A1,-(SP)
	MOVE.L	A2,-(SP)
	BSR	PRINT   
	MOVEA.L	(SP)+,A2
	MOVEA.L	(SP)+,A1
	BRA	BOTTOM
DONE	RTS
;----------------------------------------
DLX028	DC.L	DLX027
	DC.B	1,'(',0,0,0,0,0,0	;COMMENT '('
	DC.W	IMMED
CMNT	BSR	GETCX		;GET CHAR
	CMPI.B	#41,D0		;UNTIL ')'
	BNE	CMNT
	RTS
;----------------------------------------
DLX029	DC.L	DLX028
	DC.B	4,'QUIT',0,0,0	;QUIT
	DC.W	0
QUIT	MOVE.W	DSKCHAN(A5),D0
	BEQ	RESTART
	MOVE.L	D0,-(A6)
	BSR	CLOSFIL
	ADDQ.L	#4,A6
	CLR.W	DSKCHAN(A5)
	BRA	RESTART
;----------------------------------------
DLX030	DC.L	DLX029
	DC.B	3,'BYE',0,0,0,0	;BYE
	DC.W	0
SYSTEM	CLR.L	-(A6)		;EXIT 0
	LEA	PBLK1(A5),A0	;POINT TO PARAM BLK
	MOVE.W	#54,(A0)	;FUNCTION #54
	CLR.W	2(A0)		;STATUS
	MOVE.L	(A6)+,4(A0)	;TERMINATE CODE
	BRA	TRAP2		;GO DO IT
*********************************************************
*  DC.W $32FC  is MOVE.W #XX,(A1)+   compile 2 bytes
*  DC.W $22FC  is MOVE.L #XX,(A1)+   compile 4 bytes
*********************************************************
DLX031	DC.L	DLX030
	DC.B	8,'CONSTAN'	;CONSTANT
	DC.W	0   
	MOVE.L	#32,-(A6)
	BSR	WORD
	ADDQ.L	#4,A6
	BSR	HEADER
	MOVEA.L	DICT(A5),A1
	MOVE.W	#MACRO+3,-2(A1)	;MAKE IT MACRO
	MOVE.W	#$2D3C,(A1)+	;MOVE.L	#XX,-(A6)
	MOVE.L	(A6)+,(A1)+	;COMPILE VALUE
	MOVE.W	#$4E75,(A1)+	;RTS CODE
	MOVE.L	A1,DICT(A5)
	RTS			;END OF WORD
;----------------------------------------
DLX032	DC.L	DLX031
	DC.B	6,'CREATE',0	;CREATE
	DC.W	0
CREATE	MOVE.L	#32,-(A6)
	BSR	WORD                   
	ADDQ.L	#4,A6
	BSR	HEADER
	MOVEA.L	DICT(A5),A1
	DC.W	$22FC		;LONG CODE
	LEA	8(PC),A0	;CODE
	DC.W	$22FC
	MOVE.L	A0,-(A6)	;CODE
	RTS			;CODE
	MOVE.W	#$4E75,(A1)+	;CODE RTS
	MOVE.L	A1,DICT(A5)
	RTS
;----------------------------------------
DLX033	DC.L	DLX032
	DC.B	5,'ALLOT',0,0	;ALLOT
	DC.W	0
	MOVE.L	(A6)+,D0
	ADD.L	D0,DICT(A5)
	RTS
;----------------------------------------
DLX034	DC.L	DLX033
	DC.B	8,'VARIABL'	;VARIABLE
	DC.W	0     
	BSR	VARBL
	ADDQ.L	#4,A1
	MOVE.L	A1,DICT(A5)	;SAVE DICT POINTER
	RTS
VARBL	MOVE.L	#32,-(A6)	;USED BY OTHERS
	BSR	WORD                   
	ADDQ.L	#4,A6
	BSR	HEADER
	MOVEA.L	DICT(A5),A1
	DC.W	$22FC		;LONG CODE
	JSR	ADRSX(A5)	;CODE
	RTS
ADRSX	MOVE.L	(SP)+,-(A6)	;PUSH ADRS
	RTS
;----------------------------------------
DLX035	DC.L	DLX034
	DC.B	5,'DOES>',0,0	;DOES>
	DC.W	0
DOES	MOVEA.L	(SP)+,A0	;ADRS OF TARGET
	MOVEA.L	LAST(A5),A1
	LEA	16(A1),A1	;SKIP CREATE STUF
	MOVE.W	#$4EED,(A1)+	;CODE JMP X(A5)
	SUBA.L	A5,A0		;FIGURE OFFSET
	MOVE.W	A0,(A1)		;PATCH IT
	RTS			;DON'T EXECUTE IT
;----------------------------------------
DLX036	DC.L	DLX035
	DC.B	5,'BEGIN',0,0	;BEGIN
	DC.W	IMMED
	BSR	COLTST
	MOVEA.L	LOPSTK(A5),A0	;PUSH CONTROL
	MOVEQ	#0,D0		;LEAVE=0, UNUSED
	MOVE.L	D0,-(A0)	;LEAVE ADRS
	MOVE.L	DICT(A5),-(A0)	;BEGIN ADRS
	MOVEQ	#3,D0
	MOVE.W	D0,-(A0)	;BEGIN CODE
	MOVE.L	A0,LOPSTK(A5)
	ADDQ.W	#1,LOPCNT(A5)	;INC LOPCNT
	RTS
;----------------------------------------
DLX037	DC.L	DLX036
	DC.B	5,'UNTIL',0,0	;UNTIL
	DC.W	IMMED
	BSR	COLTST
	DC.W	$32FC
	TST.L	(A6)+		;CODE
	DC.W	$32FC,$6700	;CODE BEQ.L
UNT020	MOVEA.L	LOPSTK(A5),A0	;GET DO STCK
	CMPI.W	#3,(A0)+	;TEST CODE
	BNE	BADDY
	MOVEA.L	(A0)+,A2	;GET MARK
	SUBA.L	A1,A2
	MOVE.W	A2,(A1)+	;CODE OFFSET
	MOVE.L	A1,DICT(A5)
	MOVE.L	(A0)+,D0	;WHILE ADRS
	BEQ	UNT030
	MOVEA.L	D0,A2		;OLD MARK
	SUBA.L	A2,A1		;CALC OFFSET
	MOVE.W	A1,(A2)		;PATCH IT
UNT030	MOVE.L	A0,LOPSTK(A5)
	SUBQ.W	#1,LOPCNT(A5)
	BEQ	BADDY
	RTS
;----------------------------------------
DLX038	DC.L	DLX037
	DC.B	5,'WHILE',0,0	;WHILE
	DC.W	IMMED
	BSR	COLTST		;ONLY WORK IN :
	DC.W	$32FC
	TST.L	(A6)+		;CODE
	DC.W	$32FC,$6700	;CODE BEQ 
	MOVEA.L	LOPSTK(A5),A0
	MOVE.L	A1,6(A0)	;MARK
	CLR.W	(A1)+		;BEQ OFFSET
	MOVE.L	A1,DICT(A5)
	RTS
;----------------------------------------
DLX039	DC.L	DLX038
	DC.B	6,'REPEAT',0	;REPEAT
	DC.W	IMMED
	BSR	COLTST		;GET POINTER
	MOVE.W	#$6000,(A1)+	;CODE BRA.L
	BRA	UNT020		;USE UNTIL CODE
;-----------------------------------------
DLX040	DC.L	DLX039
	DC.B	2,'IF',0,0,0,0,0	;IF
	DC.W	IMMED
IF	BSR	COLTST		;ONLY WORK IN :
	DC.W	$32FC
	TST.L	(A6)+		;CODE
	DC.W	$32FC,$6700	;CODE BEQ
	MOVE.L	A1,-(A6)	;MARK
	CLR.W	(A1)+		;BEQ OFFSET
	MOVE.L	A1,DICT(A5)
	RTS
;----------------------------------------
DLX041	DC.L	DLX040
	DC.B	5,'ENDIF',0,0	;ENDIF
	DC.W	IMMED
ENDIF	BSR	COLTST		;ONLY WORK IN :
	MOVEA.L	(A6)+,A2	;OLD MARK
	SUBA.L	A2,A1		;CALC OFFSET
	MOVE.W	A1,(A2)		;PATCH IT
	RTS
;----------------------------------------
DLX042	DC.L	DLX041
	DC.B	4,'ELSE',0,0,0	;ELSE
	DC.W	IMMED
ELSE	BSR	COLTST  
	MOVEA.L	(A6)+,A2	;OLD MARK
	DC.W	$32FC,$6000	;CODE BRA
	MOVE.L	A1,-(A6)	;NEW MARK
	CLR.W	(A1)+		;BRA OFFSET
	MOVE.L	A1,DICT(A5)
	SUBA.L	A2,A1		;CALC OFFSET
	MOVE.W	A1,(A2)		;PATCH IT
	RTS
;----------------------------------------------
DLX043	DC.L	DLX042
	DC.B	2,'DO',0,0,0,0,0	;DO
	DC.W	IMMED
DO	BSR	COLTST
	DC.W	$32FC		;CODE
	MOVE.L	(A6)+,D0	;SAVE I
	DC.W	$32FC
	MOVE.L	(A6)+,-(SP)	;PUSH I'
	DC.W	$32FC
	MOVE.L	D0,-(SP)	;PUSH I
	MOVE.L	A1,DICT(A5)
	MOVEA.L	LOPSTK(A5),A0	;PUSH CONTROL
	MOVEQ	#0,D0		;LEAVE=0, UNUSED
	MOVE.L	D0,-(A0)	;LEAVE ADRS
	MOVE.L	A1,-(A0)	;DO ADRS
	MOVEQ	#2,D0
	MOVE.W	D0,-(A0)	;DO CODE
	MOVE.L	A0,LOPSTK(A5)
	ADDQ.W	#1,LOPCNT(A5)	;INC LOPCNT
	RTS
;------------------------------
DLX044	DC.L	DLX043
	DC.B	4,'LOOP',0,0,0	;LOOP
	DC.W	IMMED
LOOP    BSR	COLTST
	DC.W	$32FC
	ADDQ.L	#1,(SP)		;CODE
LOPX	MOVEA.L	LOPSTK(A5),A0	;GET DO STCK
	CMPI.W	#2,(A0)		;TEST CODE
	BNE	BADDY
	ADDQ.L	#2,A0		;DROP DO CODE
	DC.W	$32FC
	MOVE.L	(SP),D0		;CODE
	DC.W	$22FC
	CMP.L	4(SP),D0	;CODE
	DC.W	$32FC,$6D00	;CODE BLE
	MOVEA.L	(A0)+,A2	;GET MARK
	SUBA.L	A1,A2		;MAKE NEGATIVE
	MOVE.W	A2,(A1)+	;DISPLACE FOR BLE
	MOVE.L	(A0)+,D0	;LEAVE ADRS
	BEQ	LOP030
	MOVEA.L	D0,A2		;COPY LEAVE ADRS
	MOVE.L	A1,D2		;COPY DICT
	SUB.L	D0,D2		;CALC OFFSET
	MOVE.W	D2,(A2)		;PATCH IT
LOP030	MOVE.L	A0,LOPSTK(A5)
        DC.W	$32FC
	ADDQ.L	#8,SP		;CODE R2DROP
	MOVE.L	A1,DICT(A5)                
	SUBQ.W	#1,LOPCNT(A5)
	BEQ	BADDY
	RTS
;-----------------------------
DLX045	DC.L	DLX044
	DC.B	5,'+LOOP',0,0	;+ LOOP
	DC.W	IMMED
	BSR	COLTST                  
	DC.W	$32FC
	MOVE.L	(A6)+,D0
	DC.W	$32FC
	ADD.L	D0,(SP)
	BRA	LOPX		;COMPILE
;-------------------------------------
DLX046	DC.L	DLX045
	DC.B	2,'."',0,0,0,0,0	;STRING
	DC.W	IMMED
STX020	TST.W	STATE(A5)	;CHECK MODE
	BNE	STX300
STX100	BSR	GETCX		;GET NEXT CHAR
	CMPI.B	#'"',D0		;CHECK FOR "
	BEQ	STX120
	BSR	PUTD0		;SEND IT
	BRA	STX100  
STX120	RTS                     
STX300	BSR	STRCON		;COMPILE STRING
	MOVEA.L	DICT(A5),A1
	DC.W	$22FC		;LONG CODE
	JSR	STXTYP(A5)	;PRINT STRING
	MOVE.L	A1,DICT(A5)
	RTS
;------- STRING CONSTANT
STRCON	MOVEA.L	DICT(A5),A1	;GET DICT POINTER
	MOVE.W	#$6100,(A1)+	;LONG BSR
	MOVE.L	A1,-(A6)	;MARK LOCATION
	CLR.W	(A1)+		;ZAP OFFSET
	BSR.S	CMPLSTR		;COMPILE STRING
	MOVEA.L	DICT(A5),A1	;GET DICT PNTR
	MOVE.L	A1,D0		;COPY POINTER
	MOVEA.L	(A6)+,A0	;GET MARK
	SUB.L	A0,D0		;CALC OFFSET
	MOVE.W	D0,(A0)		;FIX CODE
	DC.W	$32FC
	MOVE.L	(SP)+,-(A6)	;ADRS CODE
	MOVE.L	A1,DICT(A5)
	RTS
;-------- COMPILE STRING - USED MANY PLACES
CMPLSTR	MOVEQ	#0,D1		;COUNT
STX320	MOVE.L	A1,-(SP)	;SAVE POINT
	MOVE.L	D1,-(SP)	;SAVE COUNT
	BSR	GETCX
	MOVE.L	(SP)+,D1	;GET COUNT
	MOVEA.L	(SP)+,A1	;GET POINT
	CMPI.B	#'"',D0
	BEQ	STX360
	MOVE.B	D0,1(A1,D1)	;SAVE IN DICT
	ADDQ.B	#1,D1		;BUMP COUNT
	BRA	STX320
STX360	MOVE.B	D1,(A1)		;PUT IN COUNT
	ADDQ.L	#2,D1		;MAKE IT EVEN
	AND.W	#$FFFE,D1
	ADDA.L	D1,A1		;FIX DICT
	MOVE.L	A1,DICT(A5)     
	RTS
;-----------------------------------------------------
DLX047	DC.L	DLX046
	DC.B	5,'LEAVE',0,0
	DC.W	IMMED
	BSR	COLTST		;ONLY IN COLON
	MOVE.W	#$6000,(A1)+	;BRA CODE
LEV010	MOVEA.L	LOPSTK(A5),A0
	MOVE.L	A1,6(A0)	;LEAVE ADRES
	CLR.W	(A1)+
	MOVE.L	A1,DICT(A5)
	RTS
;---------------------------------
DLX048	DC.L	DLX047
	DC.B	6,'?LEAVE',0
	DC.W	IMMED
	BSR	COLTST
	DC.W	$32FC
	TST.L	(A6)+		;CODE
	MOVE.W	#$6600,(A1)+	;BNE
	BRA	LEV010
;---------------------------------
DLX049	DC.L	DLX048                             
	DC.B	5,'AGAIN',0,0
	DC.W	IMMED
	BSR	COLTST
	MOVE.W	#$6000,(A1)+	;BRA.L CODE
	MOVEA.L	LOPSTK(A5),A0	;GET DO STCK
	CMPI.W	#3,(A0)+	;TEST CODE
	BNE	BADDY
	MOVEA.L	(A0)+,A2	;GET BEGIN MARK
	SUBA.L	A1,A2
	MOVE.W	A2,(A1)+	;CODE OFFSET
	MOVE.L	A1,DICT(A5)
	RTS
;
*************************************************
	INCLUDE FORTH01.ASM
*************************************************
*************************************************
	INCLUDE	FORTH02.ASM
*************************************************
	INCLUDE FORTH03.ASM
*************************************************
******************************************
*             INPUT ROUTINES             *
******************************************
;--- GET A LINE FROM CONSOLE   (#buf max -- siz )
GETLIN	MOVE.L	(A6)+,D0		;GET MAX SIZE
	MOVE.L	(A6),PBLK1+10(A5)	;BUFADRS
	MOVE.W	#2,PBLK1(A5)		;CMD= READ
	MOVE.W	#1,PBLK1+4(A5)		;CHANNEL= 1 (CONSOLE)
	MOVE.W	D0,PBLK1+6(A5)		;MAX COUNT
	LEA	PBLK1(A5),A0
	BSR	TRAP2			;SEND AND WAIT
	CLR.L	D0			;GET BYTES READ
	MOVE.W	PBLK1+8(A5),D0
	MOVE.L	D0,(A6)
	RTS				;BACK TO USER
******************************************
*           OUTPUT ROUTINES              *
******************************************
;--- PRINT A STRING ( adr -- )
STRPRNT	MOVEA.L	(A6)+,A0	;GET START ADRS
	MOVE.L	A0,D0		;COPY IT
SPR005	TST.B	(A0)+		;SCAN FOR 0
	BNE	SPR005
	EXG	A0,D0		;EXCHANGE
	SUB.L	A0,D0		;SUBTRACT START
	SUBQ	#1,D0		;FIX FOR ()+
	BRA	APR100		;USE ARRAY PRINT
*******************************************************
*         STORAGE -- DS ONLY FROM THIS POINT          *
*******************************************************
VARS	DC.L	0	;MARKER 0=NEW NZ=OLD
STATE	DS.L	1	;0=INTERP 1=COMPILE
SRCFLG	DS.W	1	;0=TERMINAL 1=DISK
FIMMED	DS.W	1	;0=NORMAL 1=IMMEDIATE
FCODE	DS.W	1	;0=NORMAL 1=CODE
SCPN	DS.L	1	;TERMINAL LINE SCAN POINTER
DSKBFPN	DS.L	1	;DISK INPUT BUFFER POINTER
DSKCNT	DS.W	1	;DISK INPUT COUNT
DSKCHAN	DS.W	1	;DISK INPUT CHANNEL
DICT	DS.L	1	;START OF DICTIONARY POINTER
CONTEXT	DS.L	1	;SEARCH DICTIONARY
CURRENT	DS.L	1	;ADD TO DICTIONARY
VOCAB	DS.L	1	;VOCAB POINTER
LAST	DS.L	1	;ADRES OF LAST DEF WORD
FENCE	DS.L	1	;FORGET/CLEAR LIMIT
BASE	DS.L	1	;CURRENT NUMBER BASE
SPAN	DS.L	1	;USER VARIABLE
HLD	DS.L	1	;HOLD POINTER
;-----------------------------------------------------
LOPCNT	DS.W	1	;LOOP COMPILE COUNTER
	DS.L	30	;LOOP COMPILE STACK
LOPSTK	DS.L	1	;LOOP COMPILE STACK POINTER   
LGGCNT	DS.W	1	;LOGICAL COMPILE COUNTER
	DS.L	30	;LOGICAL STACK
LGGPNT	DS.L	1	;LOGICAL POINTER
;-----------------------------------------------------
COUNT	DS.W	1	;GENERAL COUNTER
POINT1	DS.L	1	;GENERAL POINTER
POINT2	DS.L	1	;GENERAL POINTER
PBLK1	DS.W	30	;PARAM BLOCK #1
NBUF	DS.W	20	;DIGIT AND WORD BUFER
IBUF	DS.W	64	;TERMINAL IN BUFFER
PAD	DS.W	64	;PAD
DSKBUF	DS.W	256	;512 BYTES OF DISK BUFFER
	DS.L	128	;128*4=512 BYTES
RTNSTK	DS.L	1	;128 LEVELS OF RETURN STACK
	DS.L	128	;128*4=512 BYTES
PARSTK	DS.L	1	;128 LEVELS OF PARAM STACK
	DS.L	8
DICTIN	DS.L	1	;START OF USER DICTIONARY
	END

